import React, { useState, useEffect } from 'react';
import { Modal, Form, Input, Button, Select, Switch } from 'antd';

const CreateRecordForm = (props) => {
    const [isAdd,setisAdd] = useState(false);
    return (
        <Modal
            width={800}
            visible={props.createModalVisible}
            bodyStyle={{ padding: '32px 40px 48px' }}
            footer={null}
            onCancel={() => {
                props.onCancel();
            }}
            destroyOnClose
        >
            <Form
                layout="Vertical"
                labelCol={{ span: 6 }}
                initialValues={props.values}
                onFinish={props.onFinish}
                onCancel={props.onCancel}
            >
                <Form.Item name="id" hidden={true}>
                    <Input />
                </Form.Item>
                <Form.Item label='做法名称' name={'practiceName'} >
                    <Input></Input>
                </Form.Item>
                <Form.Item label='做法类别' name={'practiceTypeId'} >
                    <Select style={{ width: '300px' }}
                    >
                        {
                            (props.TypeList || []).map((item, index) => {
                                return (
                                    <Select.Option index={index} value={item.id} key={item.typeName}>
                                        {item.typeName}
                                    </Select.Option>
                                );
                            })
                        }
                    </Select>
                </Form.Item>
                <Form.Item label='加价' name={'isRaise'} valuePropName="checked" >
                    <Switch onChange={(_,record)=>{
                        setisAdd(_);
                    }} />
                </Form.Item>
                <Form.Item label='加价方式' name={'raiseType'} >
                    <Select style={{ width: '300px' }} disabled={!isAdd}>
                        <Option value={"1"} >
                            按出品数量加价
                        </Option>
                        <Option value={"2"}>
                            加价与出品数量无关
                        </Option>
                    </Select>
                </Form.Item>
                <Form.Item>
                    <Button type="primary" htmlType="submit" >
                        保存
                    </Button>
                </Form.Item>
            </Form>
        </Modal>
    );
};

export default CreateRecordForm;