import React, { useState, useEffect } from 'react';
import { Modal, Form, Input, Button, Select, Switch } from 'antd';


const createRelevanceForm = (props) => {
    return (
        <Modal
            width={800}
            visible={props.createModalVisible}
            bodyStyle={{ padding: '32px 40px 48px' }}
            footer={null}
            onCancel={() => {
                props.onCancel();
            }}
            destroyOnClose
        >
            <Form
                layout="Vertical"
                labelCol={{ span: 6 }}
                initialValues={props.values}
                onFinish={props.onFinish}
                onCancel={props.onCancel}
            >
                <Form.Item name="id" hidden={true}>
                    <Input />
                </Form.Item>
                <Form.Item name="relevanceType" initialValue={props.domrelevanceType} hidden={true} >
                    <Input />
                </Form.Item>
                <Form.Item label='商品小类' name={'goodsSmallType'} hidden={props.domrelevanceType == 2} initialValue={props.values.goodsSmallType}>
                    <Select style={{ width: '300px' }}
                    >
                        {
                            (props.Support.allSmallType || []).map((item, index) => {
                                return (
                                    <Select.Option index={index} value={item.id} key={item.id}>
                                        {item.goodsType_Name}
                                    </Select.Option>
                                );
                            })

                        }
                    </Select>
                </Form.Item>
                <Form.Item label='做法类别' name={'practiceTypeId'} hidden={props.domrelevanceType == 2} initialValue={props.values.practiceTypeId}>
                    <Select style={{ width: '300px' }}
                    >
                        {
                            (props.Support.allType || []).map((item, index) => {
                                return (
                                    <Select.Option index={index} value={item.id} key={item.id}>
                                        {item.typeName}
                                    </Select.Option>
                                );
                            })

                        }
                    </Select>
                </Form.Item>
                <Form.Item label='商品' name={'goodsId'} hidden={props.domrelevanceType == 1} initialValue={props.values.goodsId}>
                    <Select style={{ width: '300px' }}
                    >
                        {
                            (props.Support.allGoods || []).map((item, index) => {
                                return (
                                    <Select.Option index={index} value={item.id} key={item.id}>
                                        {item.name}
                                    </Select.Option>
                                );
                            })

                        }
                    </Select>
                </Form.Item>
                <Form.Item label='做法' name={'practiceIds'} hidden={props.domrelevanceType == 1}  initialValue={props.values.practiceIds || []}> 
                    <Select style={{ width: '300px' }}
                        mode="multiple"
                    >
                        {
                            (props.Support.allPractice || []).map((item, index) => {
                                return (
                                    <Select.Option index={index} value={item.id} key={item.id}>
                                        {item.practiceName}
                                    </Select.Option>
                                );
                            })

                        }
                    </Select>
                </Form.Item>
                <Form.Item>
                    <Button type="primary" htmlType="submit" >
                        保存
                    </Button>
                </Form.Item>
            </Form>
        </Modal>
    );
};

export default createRelevanceForm;