import React from 'react';
import { Input, Modal, Form, Select, Button, InputNumber } from 'antd';
const CreateForm = (props) => {
  const { Option, OptGroup } = Select;
  return (
    <Modal
      title={props.values.id ? '编辑' : '新建'}
      width={640}
      visible={props.modalVisible}
      bodyStyle={{ padding: '32px 40px 48px' }}
      footer={null}
      onCancel={() => {
        props.onCancel();
      }}
      destroyOnClose
      maskClosable={false}
    >
      <Form
        layout="horizontal"
        labelCol={{ span: 4 }}
        preserve={false}
        initialValues={props.values}
        onFinish={props.onFinish}
      >
        <Form.Item name="id" hidden={true}>
          <Input />
        </Form.Item>
        <Form.Item name="name" label="企业名称" rules={[{ required: true, max: 30 }]}>
          <Input placeholder="请输入企业名称" />
        </Form.Item>
        <Form.Item name="adminName" label="管理员名称" rules={[{ required: true, max: 20 }]}>
          <Input placeholder="请输入管理员名称" />
        </Form.Item>
        <Form.Item name="settlementCycles" label="结算周期" rules={[{ required: true}]}>
          <InputNumber step={1} min={1} max={100} defaultValue={1} precision={0} />
        </Form.Item>
        <Form.Item name="host" label="主机" rules={[{ max: 100 }]}>
          <Input placeholder="请输入主机" />
        </Form.Item>


        <Form.Item name="email" label="电子邮件" rules={[{ required: true, max: 50 }]}>
          <Input placeholder="请输入电子邮件" />
        </Form.Item>
        <Form.Item name="connection" label="数据库连接" rules={[{ max: 200 }]}>
          <Input placeholder="请输入数据库连接" />
        </Form.Item>
        <Form.Item name="phone" label="电话" rules={[{ max: 20 }]}>
          <Input placeholder="请输入电话" />
        </Form.Item>
        <Form.Item name="schema" label="架构" rules={[{ max: 50 }]}>
          <Input placeholder="请输入架构" />
        </Form.Item>
        <Form.Item name="supplyPlatformId" label="供应商平台key" rules={[{ max: 300 }]}>
          <Input placeholder="请输入供应商平台key" />
        </Form.Item>

        <Form.Item name="realmName" label="请求域名" rules={[{ max: 300 }]}>
          <Input placeholder="请求域名" />
        </Form.Item>

        
        <Form.Item name="remark" label="备注" rules={[{ max: 100 }]}>
          <Input placeholder="请输入备注" />
        </Form.Item>
        <Form.Item>
          <Button type="primary" htmlType="submit">
            保存
          </Button>
        </Form.Item>
      </Form>
    </Modal>
  );
};

export default CreateForm;
