import React, { useEffect, useState } from 'react';
import { Modal, Form, Select, Button } from 'antd';
import api from './service';

const OrgForm = (props) => {
  const [org, setOrg] = useState([]);

  useEffect(() => {
    var arr = [];
    api.GetOrg().then(r => {
      for (var item in r.data) {
        arr.push(<Option value={item}>{r.data[item]}</Option>)
      }
      setOrg(arr);
    })
  }, [props.values]);

  return (
    <Modal
      width={640}
      bodyStyle={{ padding: '32px 40px 48px' }}
      destroyOnClose
      title={`给 ${props.values.name} 授权数据`}
      visible={props.updateModalVisible}
      footer={null}
      onCancel={() => props.onCancel()}
    >
      <Form
        layout="vertical"
        preserve={false}
        layout="horizontal"
        labelCol={{
          span: 4,
        }}
        onFinish={props.onFinish}
        initialValues={props.values}
      >
        <Form.Item
          name="dataScopeType"
          label="授权范围"
          rules={[{ required: true, message: '请选择授权范围' }]}
        >
          <Select
            allowClear
            placeholder="请选择授权范围"
          >
            <Select.Option value={1}>个人数据</Select.Option>
            <Select.Option value={2}>全部数据</Select.Option>
            <Select.Option value={3}>自定义数据</Select.Option>
          </Select>
        </Form.Item>
        {props.values.dataScopeType != 3 ? null: (
          <Form.Item
            name="sysOrgId"
            label="选择机构"
            rules={[{ required: true, message: '选择机构' }]}
          >
            <Select allowClear placeholder='请选择机构' mode='multiple'>
              {org}
            </Select>
          </Form.Item>
        )}
        <Form.Item>
          <Button type="primary" htmlType="submit" style={{float:'right'}}>
            保存
          </Button>
        </Form.Item>
      </Form>
    </Modal>
  );
};

export default OrgForm;
